trace = 		as.numeric(read.csv("sim.csv", header=F, sep=","))
trace_overlap = as.numeric(read.csv("sim_overlap.csv", header=F, sep=","))
trace_distr = 	as.numeric(read.csv("sim_distr.csv", header=F, sep=","))
trace_d_o = as.numeric(read.csv("sim_distr_overlap.csv", header=F, sep=","))


pType = "l"
xLabel = "Time"
yLabel = "Leakage"
yLimit = c(0,6.5)

pdf("sim_parameters.pdf", 6,4)
par(mfrow=c(2,2))

mainCoef = 1.5
labCoef = 1.2

plot(trace,			type=pType, ylab=yLabel, xlab=xLabel, ylim=yLimit, main="Simple simulation", cex.main=mainCoef, cex.lab=labCoef)
plot(trace_overlap,	type=pType, ylab=yLabel, xlab=xLabel, ylim=yLimit, main="Overlap", cex.main=mainCoef, cex.lab=labCoef)
plot(trace_distr,	type=pType, ylab=yLabel, xlab=xLabel, ylim=yLimit, main="Leakage distribution", cex.main=mainCoef, cex.lab=labCoef)
plot(trace_d_o,		type=pType, ylab=yLabel, xlab=xLabel, ylim=yLimit, main="Leakage distribution &\nOverlap", cex.main=mainCoef, cex.lab=labCoef)

dev.off()

pdf("constant_leakage.pdf", 6,4)
plot(trace,	type=pType, ylab=yLabel, xlab=xLabel, ylim=yLimit, main="", cex.lab=1.4)
dev.off()

pdf("overlap_leakage.pdf", 6,4)
plot(trace_overlap,	type=pType, ylab=yLabel, xlab=xLabel, ylim=yLimit, main="", cex.lab=1.4)
dev.off()

pdf("sin_leakage.pdf", 6,4)
plot(trace_distr,	type=pType, ylab=yLabel, xlab=xLabel, ylim=yLimit, main="", cex.lab=1.4)
dev.off()

pdf("sin_overlap_leakage.pdf", 6,4)
plot(trace_d_o,		type=pType, ylab=yLabel, xlab=xLabel, ylim=yLimit, main="", cex.lab=1.4)
dev.off()
